hdu 2829

Lawrence

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2484    Accepted Submission(s): 1105

Problem Description

T. E. Lawrence was a controversial figure during World War I. He was a British officer who served in the Arabian theater and led a group of Arab nationals in guerilla strikes against the Ottoman Empire. His primary targets were the railroads. A highly fictionalized version of his exploits was presented in the blockbuster movie, "Lawrence of Arabia".

You are to write a program to help Lawrence figure out how to best use his limited resources. You have some information from British Intelligence. First, the rail line is completely linear---there are no branches, no spurs. Next, British Intelligence has assigned a Strategic Importance to each depot---an integer from 1 to 100. A depot is of no use on its own, it only has value if it is connected to other depots. The Strategic Value of the entire railroad is calculated by adding up the products of the Strategic Values for every pair of depots that are connected, directly or indirectly, by the rail line. Consider this railroad: 

Its Strategic Value is 4*5 + 4*1 + 4*2 + 5*1 + 5*2 + 1*2 = 49.

Now, suppose that Lawrence only has enough resources for one attack. He cannot attack the depots themselves---they are too well defended. He must attack the rail line between depots, in the middle of the desert. Consider what would happen if Lawrence attacked this rail line right in the middle: 

The Strategic Value of the remaining railroad is 4*5 + 1*2 = 22. But, suppose Lawrence attacks between the 4 and 5 depots: 

The Strategic Value of the remaining railroad is 5*1 + 5*2 + 1*2 = 17. This is Lawrence‘s best option.

Given a description of a railroad and the number of attacks that Lawrence can perform, figure out the smallest Strategic Value that he can achieve for that railroad.

Input

There will be several data sets. Each data set will begin with a line with two integers, n and m. n is the number of depots on the railroad (1≤n≤1000), and m is the number of attacks Lawrence has resources for (0≤m<n). On the next line will be n integers, each from 1 to 100, indicating the Strategic Value of each depot in order. End of input will be marked by a line with n=0 and m=0, which should not be processed.

Output

For each data set, output a single integer, indicating the smallest Strategic Value for the railroad that Lawrence can achieve with his attacks. Output each integer in its own line.

Sample Input

4 1
4 5 1 2
4 2
4 5 1 2
0 0

Sample Output

17
2

Source

2009 Multi-University Training Contest 2 - Host by TJU

Recommend

gaojie   |   We have carefully selected several similar problems for you:  2830 2832 2828 2827 2833

题目描述 :

在一条具有n个仓库的道路上,放置m个炸弹,被炸断之后的这段铁路[i,j],它的值为a[i]*(a[i+1],,,,a[j])+a[i+1]*a(a[i+2],,,+a[j])+,,,,+a[j-1]*a[j];,求被炸弹分割之后的铁路和的最小值


The Strategic Value of the remaining railroad is 5*1 + 5*2 + 1*2 = 17.

d[i][k]表示在前i个仓库里放k个炸弹,cost[i][j]表示[i,j]区间内的Strategic Value

d[i][k]=min(d[j][k-1]+cost[j+1][i]);

cost[i][j]=cost[i][j-1]+sum*a[j],sum==(a[i]+a[i+1]+a[i+2]+,,,,+a[j-1])

时间复杂度为1000*1000*1000=10^9,肯定会超时。

可以采用斜率优化或者四边形优化。

目前只会四边形优化,还有此题wa了很久的原因是无穷大的设立,inf=1<<20,不够大,inf=1e30才够大,

提醒我们需要注意细节。

设立初始值,d[i][0]=cost[1][i],用s[i][j]表示d[i][j]的决策。s[i][0]=0,s[n+1][i]=n;

1:s[i][k-1]<=s[i][k]<=s[i+1][k];

2:d[i][k]=min(d[j][k-1]+cost[j+1][i]);

观察表达式,k从小到大枚举(2式),i从大到小枚举(1式中s[i][k]<=s[i+1][k])。k在外层循环,i在内层循环(1式中s[i][k]<=s[i+1][k])

#include <iostream>
#include <cstdio>
#include <cstring>
#define M 1100
#define LL long long
const int inf =1e18;
using namespace std;
int n,m;
LL a[1100];
LL cost[M][M];
LL d[M][M];
int s[M][M];
void init()
{
   memset(d,0,sizeof(d));
   memset(cost,0,sizeof(cost));
   memset(s,0,sizeof(s));
}

void solve()
{
    /* for(int i=1;i<=n;i++)
     {
        LL sum=0;
        int j;
        for(int t=1;t<=n;t++)
        {
          j=i+t;
          if(j>n)
          break;
          sum+=a[j-1];
          cost[i][j]=cost[i][j-1]+sum*a[j];
        }
     }*/
    for(int i=1;i<=n;i++){
    LL sum=0;
    cost[i][i]=0;
    for(int j=i+1;j<=n;j++){
      sum+=a[j-1];
      cost[i][j]=cost[i][j-1]+sum*a[j];
    }
  }

    /*  for(int i=1;i<=n;i++)
       {for(int j=1;j<=n;j++)
        printf("%d ",cost[i][j]);
        printf("\n");
        }
        printf("\n");
      */
      for(int i=0;i<=n;i++)
      {
         s[i][0]=0;
         s[n+1][i]=n;
          d[i][0]=cost[1][i];
      }
      for(int k=1;k<=m;k++)
       for(int i=n;i>=1;i--)
      {
                    d[i][k]=1e18;
                    for(int j=s[i][k-1];j<=s[i+1][k];j++)
                    {
                      if((d[j][k-1]+cost[j+1][i])<d[i][k])
                      {
                        d[i][k]= d[j][k-1]+cost[j+1][i];
                        s[i][k]=j;
                      }
                    }
      }
     /* for(int i=0;i<=n+1;i++)
       {for(int j=0;j<=m;j++)
        printf("%d ",s[i][j]);
        printf("\n");
        }
        printf("\n");
        for(int i=0;i<=n;i++)
       {for(int j=0;j<=m;j++)
        printf("%d ",d[i][j]);
        printf("\n");
        }
        printf("\n");*/
       printf("%lld\n",d[n][m]);
}

int main()
{
  //freopen("test.txt","r",stdin);
   while(scanf("%d%d",&n,&m))
   {
      if(n==0&&m==0)
      break;
       init();
      for(int i=1;i<=n;i++)
      scanf("%lld",&a[i]);
      solve();
   }
    return 0;
}
时间: 2024-10-08 20:10:05

hdu 2829的相关文章

HDU 2829 Lawrence(动态规划-四边形不等式)

Lawrence Problem Description T. E. Lawrence was a controversial figure during World War I. He was a British officer who served in the Arabian theater and led a group of Arab nationals in guerilla strikes against the Ottoman Empire. His primary target

HDU 2829 Lawrence

Lawrence Time Limit: 1000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 282964-bit integer IO format: %I64d      Java class name: Main T. E. Lawrence was a controversial figure during World War I. He was a British officer w

HDU 2829 Lawrence (斜率优化DP或四边形不等式优化DP)

题意:给定 n 个数,要你将其分成m + 1组,要求每组数必须是连续的而且要求得到的价值最小.一组数的价值定义为该组内任意两个数乘积之和,如果某组中仅有一个数,那么该组数的价值为0. 析:DP状态方程很容易想出来,dp[i][j] 表示前 j 个数分成 i 组.但是复杂度是三次方的,肯定会超时,就要对其进行优化. 有两种方式,一种是斜率对其进行优化,是一个很简单的斜率优化 dp[i][j] = min{dp[i-1][k] - w[k] + sum[k]*sum[k] - sum[k]*sum[

hdu 2829 dp+四边形不等式优化

用w[i][j]表示i到j之间没有边毁掉的费用. 有一种很好证明w[i][j]是否满足四边形不等式的条件. 若(w[i+1][j]-w[i][j])是关于j的减函数,就是满足条件的.可以证明这里的w[i][j]是瞒住条件的. #include <set> #include <map> #include <queue> #include <stack> #include <cmath> #include <string> #includ

HDU 2829 Lawrence (斜率DP)

斜率DP 设dp[i][j]表示前i点,炸掉j条边的最小值.j<i dp[i][j]=min{dp[k][j-1]+cost[k+1][i]} 又由得出cost[1][i]=cost[1][k]+cost[k+1][i]+sum[k]*(sum[i]-sum[k]) cost[k+1][i]=cost[1][i]-cost[1][k]-sum[k]*(sum[i]-sum[k]) 代入DP方程 可以得出 y=dp[k][j-1]-cost[1][k]+sum[k]^2 x=sum[k]. 斜率s

【HDU 2829】Lawrence

Lawrence Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2427    Accepted Submission(s): 1078 Problem Description T. E. Lawrence was a controversial figure during World War I. He was a British

Lawrence HDU - 2829 斜率dp

#include<cstdio> #include<cstring> #include<iostream> #include<algorithm> using namespace std; const int MAX = 1000+10; //dp[i][j]:把前 i 个数分成 j 段后能得到的序列的最小权值和 //dp[i][j] = min( dp[k][j-1] + cost[i] - cost[k] - sum[k] *(sum[i] - sum[

ACM总结——dp专辑(转)

感谢博主——      http://blog.csdn.net/cc_again?viewmode=list       ----------  Accagain  2014年5月15日 动态规划一直是ACM竞赛中的重点,同时又是难点,因为该算法时间效率高,代码量少,多元性强,主要考察思维能力.建模抽象能力.灵活度. 本人动态规划博客地址:http://blog.csdn.net/cc_again/article/category/1261899 ***********************

【DP专辑】ACM动态规划总结

转载请注明出处,谢谢.   http://blog.csdn.net/cc_again?viewmode=list          ----------  Accagain  2014年5月15日 动态规划一直是ACM竞赛中的重点,同时又是难点,因为该算法时间效率高,代码量少,多元性强,主要考察思维能力.建模抽象能力.灵活度. 本人动态规划博客地址:http://blog.csdn.net/cc_again/article/category/1261899 ******************